//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  [System]^vɂ[OleContainer]Excel\D
//  TExcelApplicationR|[lggp 
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2005N0130 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE5(UP2) Pro VCL-32 + Excel 2010
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Excel2000, Vcl.OleServer,
  Vcl.OleCtnrs, Vcl.StdCtrls, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    ExcelApplication1: TExcelApplication;
    ExcelWorkbook1: TExcelWorkbook;
    ExcelWorksheet1: TExcelWorksheet;
    OleContainer1: TOleContainer;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure ExcelApplication1SheetChange(ASender: TObject;
      const Sh: IDispatch; const Target: ExcelRange);
    procedure ExcelApplication1SheetActivate(ASender: TObject;
      const Sh: IDispatch);
  private
    { Private 錾 }
  public
    { Public 錾 }
    FCellChangeFlag : Boolean;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  // ɋÑGNZƑ𕪗邽
  // ̃vOŐIuWFNgΏۂƂ
  ExcelApplication1.ConnectKind := ckRunningInstance;
end;

//=============================================================================
//  tH[\Jn̏
//
//  (1)\ubN͋NtH_̏OleTest.xlsƂ
//  (2)OleContainer̃IuWFNgt@CǏoCreate
//     CreateObjectFromFilëɖړĨubNw肷
//  (3)ÔOleContainer.Visible:=TureƂĕ\(DoVerv̈ovShow)
//  (4)\ubNTExcelApplicationIuWFNgƊ֘AÂ
//=============================================================================
procedure TForm1.FormShow(Sender: TObject);
var
  LFilePath : string;
begin
  //Z̕ҏWԂ̃tO
  FCellChangeFlag := False;
  //JubN
  LFilePath := ExpandFileName('..\OleTest.xls');
  if not FileExists(LFilePath) then exit;

  //Excel̃t@COLEReĩIuWFNgƂ
  OleContainer1.CreateObjectFromFile(LFilePath,False);

  //OLEIuWFNg\\Ԃ
  OleContainer1.Visible := True;
  //OLEIuWFNgANeBuɂ
  OleContainer1.DoVerb(ovPrimary);
  OleContainer1.SetFocus;

  ExcelApplication1.Connect;
  //JĂubNExcleWorkbook1ɐڑ
  ExcelWorkbook1.ConnectTo(ExcelApplication1.ActiveWorkbook as _workbook);
  //V[g ExcelWorksheetɐڑ
  ExcelWorksheet1.ConnectTo(ExcelWorkbook1.ActiveSheet as _Worksheet);

  //'A1'ZI
  // ̑삪Ȃꍇ͒l͍ς݂̍̃Z[ɕ\
  ExcelWorkSheet1.Range['A1', 'A1'].Select;
end;

//=============================================================================
//  tH[鎞̏
//
//  V[ge̕ύXOleContainerModifiedvpeBło\
//  Modified̓Z̎ۂ̕ύXł͂Ȃ삪o
//=============================================================================
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  LFileName      : OleVariant;
  LobjDialogItem : OleVariant;
begin
  if OleContainer1.State = osEmpty then exit;

  //ǂ̃ZɕύXۑ_CAO\
  try
    if FCellChangeFlag then begin
      //ۑt@C̃tpX
      LFileName := ExpandFileName('..\OleTest_01.xls');

      try
        //TExcelApplication.Dialogs\bĥ͈
        //ȗ邽߂OleVariant^ňƂɂ
        LobjDialogItem := ExcelApplication1.Dialogs.Item[xlDialogSaveAs];
        LobjDialogItem.Show(Arg1 := LFileName);
      except
        //ۑ_CAO[LZ]ŕƉ̂XG[
      end;
    end;

    Sleep(100);
    Application.ProcessMessages;

  finally
    //ԂDisconnect
    //TExcelApplicationQuit͕Kv
    ExcelWorkSheet1.Disconnect;
    ExcelWorkBook1.Close;
    ExcelWorkBook1.Disconnect;
    ExcelApplication1.Disconnect;
  end;
end;

//=============================================================================
//  tH[j̏
//
//  OleContainer̃IuWFNgj
//  TExcelApplicationDisconnect̏sƃ[N
//  ̎_OleContainer̃IuWFNg͊ɂȂ
//  ̃R[hُ͈Iɔ
//=============================================================================
procedure TForm1.FormDestroy(Sender: TObject);
begin
  OleContainer1.DestroyObject;
end;

//=============================================================================
//  TExcelApplication1OnSheetActiveCxg
//
//  ANeBuȃV[gς_CAO\
//=============================================================================
procedure TForm1.ExcelApplication1SheetActivate(ASender: TObject;
  const Sh: IDispatch);
begin
  MessageBox(Handle, 'V[gς', '', MB_ICONINFORMATION);
end;

//=============================================================================
//  TExcelApplication1OnSheetChangeCxg
//
//  V[g(Z)ɕύXChangeFalTrueɂĂ
//  ̃Cxg͎ۂ̕ύXȂĂҏWԂIƔ
//  TExcelWorkSheetOnChangeCxgႤœ͓
//  Z̕ҏWOleContainerModifiedvpeBło\
//=============================================================================
procedure TForm1.ExcelApplication1SheetChange(ASender: TObject;
  const Sh: IDispatch; const Target: ExcelRange);
begin
  FCellChangeFlag := True;
end;

end.
