//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  [System]^vɂ[OleContainer]Excel\
//  TExcelApplicationR|[lggp 
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2018N1023 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE5(UP2) Pro VCL-32 + Excel 2010
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Excel2000, Vcl.OleServer,
  Vcl.OleCtnrs, Vcl.StdCtrls, Vcl.ExtCtrls, ExcelXP;

type
  TForm1 = class(TForm)
    ExcelApplication1: TExcelApplication;
    ExcelWorkbook1: TExcelWorkbook;
    ExcelWorksheet1: TExcelWorksheet;
    Panel1: TPanel;
    Panel2: TPanel;
    OleContainer1: TOleContainer;
    Button1: TButton;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ExcelApplication1WorkbookOpen(ASender: TObject;
      const Wb: _Workbook);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=============================================================================
//  tH[̏
//
//  p{^ނzu邽߂TPanelzu
//  TPanelLockedvpeBTrueɂ̂|Cg
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Panel1.Caption := '';
  Panel2.Caption := '';
  Panel1.Locked  := True;

  Button2.Enabled := False;

  // ɋÑGNZƑ𕪗邽
  // ̃vOŐIuWFNgΏۂƂ
  ExcelApplication1.ConnectKind := ckNewInstance;

  // TOleContainer.AutoActivate := aaGetFocus ɂĂ
  // TOleContainer.SetFocus OLEIuWFNgANeBuɂȂ
  OleContainer1.AutoActivate := aaGetFocus;
end;

//=============================================================================
//  tH[鎞̏
//=============================================================================
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  LExcelWnd : HWND;
begin
  if OleContainer1.State = osEmpty then begin
    exit;
  end;

  // GNZ̃EBhE[ESC]L[𑗐M
  // Zւ̓͒ɏIƃG[ɂȂ̂ł̑΍
  LExcelWnd := FindWindow('XLMAIN', nil);
  PostMessage(LExcelWnd, WM_KEYDOWN, VK_ESCAPE, $00010001);
  PostMessage(LExcelWnd, WM_KEYUP,   VK_ESCAPE, $C0010001);

  // {Rg[͕\ɂ
  //  {͌̏ԂޔĂČ̒lɂׂ
  ExcelApplication1.ExecuteExcel4Macro('SHOW.TOOLBAR("Ribbon", True)');

  //ԂDisconnect
  //TExcelApplicationQuit͕sv
  ExcelWorkSheet1.Disconnect;
  ExcelWorkBook1.Close(False);
  ExcelWorkBook1.Disconnect;
  ExcelApplication1.Disconnect;
end;

//=============================================================================
//  tH[j̏
//
//  OleContainer̃IuWFNgj
//  TExcelApplicationDisconnect̏sƃ[N
//  ̎_OleContainer̃IuWFNg͊ɂȂ
//  ̃R[hُ͈Iɔ
//=============================================================================
procedure TForm1.FormDestroy(Sender: TObject);
begin
  OleContainer1.DestroyObject;
end;

//=============================================================================
//  GNZ̃ubNǂݍŕ\
//
//  2ȏsƏIɃ[N
//  [N̒l͎s񐔂Ɋ֌WȂ
//  Ώ@ɂĂ͕s
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LFilePath : string;
begin
  if ExcelApplication1.Visible[0] then begin
    //݂̃V[gƃubNDisconnect
    //ݐڑĂubNؒf
    ExcelWorkSheet1.Disconnect;
    ExcelWorkBook1.Close(False);
    ExcelWorkBook1.Disconnect;
    ExcelApplication1.Disconnect;
  end;

  //JubN
  LFilePath := ExpandFileName('..\OleTest.xls');
  if not FileExists(LFilePath) then exit;

  //OLEIuWFNg𐶐
  OleContainer1.CreateObjectFromFile(LFilePath, True);
  //OLEIuWFNgANeBuɂ
  OleContainer1.DoVerb(ovShow);

  // TExcelApplicationɐڑ
  ExcelApplication1.Connect;
  //\ĂubNExcleWorkbook1ɐڑ
  ExcelWorkbook1.ConnectTo(ExcelApplication1.ActiveWorkbook as _workbook);
  //V[g ExcelWorksheetɐڑ
  ExcelWorksheet1.ConnectTo(ExcelWorkbook1.ActiveSheet as _Worksheet);

  // ̈ʒuɕ\Zw肷
  ExcelApplication1.ActiveWindow.ScrollColumn := 1;
  ExcelApplication1.ActiveWindow.ScrollRow    := 1;

  //'A1'ZI
  ExcelWorkSheet1.Range['C4', 'C4'].Select;

  Button2.Enabled := True;
end;

//=============================================================================
//  ݕ\̃ubNۑ
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
var
  LSaveFilePath  : OleVariant;
  LFileFormat    : OleVariant;
  LPassword      : OleVariant;
  LWritePassword : OleVariant;
  LReadOnly      : OleVariant;
  LCreateBackup  : OleVariant;
  LAccessMode    : OleVariant;
begin
  LSaveFilePath := ExpandFileName('..\OleTest_01.xls');

  //ۑ`̎w
  LFileFormat    := EmptyParam;
  LPassword      := '';
  LWritePassword := '';
  LReadOnly      := False;
  LCreateBackup  := False;
  LAccessMode    := xlNoChange;

  try
    //OLEIuWFNgANeBuɂ
    //ꂪȂƃ_CAO\ɃGNZȂȂ
    //{Rg[\ɂĂ\Ă܂
    OleContainer1.DoVerb(ovPrimary);

    // ̈ʒuɕ\Zw肷
    ExcelApplication1.ActiveWindow.ScrollColumn := 1;
    ExcelApplication1.ActiveWindow.ScrollRow    := 1;

    // SaveAs͕ʖۑp̃\bh
    // ͏ȗs
    ExcelWorkbook1.SaveAs( LSaveFilePath,   //ۑt@C
                         LFileFormat,   //ۑ`.݂̃GNZ̃o[W`
                         LPassword,     //pX[h
                         LWritePassword,//ǏopX[hw
                         LReadOnly,     //ǎp\̗L
                         LCreateBackup, //obNAbvt@C쐬
                         LAccessMode,   //ANZX[h
                         EmptyParam,    //ubNL̏ꍇ̃RtNg̉@
                         EmptyParam,    //ŋߎgpt@C̈ꗗubNɒǉ
                         EmptyParam,    //TextCodePage
                         EmptyParam,    //TextVisualLayout
                         EmptyParam,
                         EmptyParam);
   except
     //[LZ]IƗO
   end;
end;

//=============================================================================
//  TExcelApplicationOnWorkbookOpenCxg
//  ubN\ɔCxg1
//=============================================================================
procedure TForm1.ExcelApplication1WorkbookOpen(ASender: TObject;
  const Wb: _Workbook);
begin
  // {Rg[\ɂ
  ExcelApplication1.ExecuteExcel4Macro('SHOW.TOOLBAR("Ribbon", False)');
end;

end.
